<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Profiler.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.util</a> &gt; <span class="el_source">Profiler.java</span></div><h1>Profiler.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.util;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

<span class="nc" id="L24">public class Profiler {</span>
<span class="nc" id="L25">    private static final Logger LOG = LoggerFactory.getLogger(Profiler.class);</span>

<span class="nc" id="L27">    public interface Operation&lt;T&gt; {</span>
        public T execute() throws Exception;
    }

    public static &lt;T&gt; T profile(Operation&lt;T&gt; op, long timeout, String message)
            throws Exception {
<span class="nc" id="L33">        long start = System.currentTimeMillis();</span>
<span class="nc" id="L34">        T res = op.execute();</span>
<span class="nc" id="L35">        long end = System.currentTimeMillis();</span>
<span class="nc bnc" id="L36" title="All 2 branches missed.">        if (end - start &gt; timeout) {</span>
<span class="nc" id="L37">            LOG.info(&quot;Elapsed &quot;+(end - start) + &quot; ms: &quot; + message);</span>
        }
<span class="nc" id="L39">        return res;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>